package edu.kit.ipd.descartes.adaptation.event;

public enum EventTypeEnum {
    
    SLA_VIOLATION("SlaViolatedEvent", "12345"), 
    SCHEDULED_OPTIMIZATION("ScheduledOptimizationEvent","_H_MTgIAnEeKW2vVcg5ekRw"), 
    BOTTLENECK_FOUND("BottleneckFoundEvent", "_VvZEwKEoEeKDl52Xojo4CQ"), 
    CUSTOMER_WORKLOAD_UPDATE("CustomerWorkloadUpdate", "_XvZEwKEoEeKDl52Xojo4KQ"),
    OPTIMIZATION_PERIOD("OptimizationPeriod","_E6I-wMwxEeKRorfNQMmH1Q"),
    CUSTOMER_REDUCES_WORKLOAD("CustomerReducesWorkload","_NkFRcN_4EeKStv3brthjgQ"),
    WORKLOAD_UPDATE_CUSTOMBER_B("WorkloadUpdate-CustomerB","_-oOCkOesEeK-n49tvUhS6w"),
    SLA_VIOLATED_CUSTOMBER_A("SLAviolated-CustomerA","_Az4tQOfLEeK-n49tvUhS6w");

    private final String name;
    private final String id;

    public String getId() {
        return id;
    }
    
    public String getName() {
        return name;
    }

    EventTypeEnum(String name, String id) {
        this.name = name;
        this.id = id;
    }

    public static EventTypeEnum getEventType(String eventTypeName) {
        if (eventTypeName.equals(SLA_VIOLATION.name))
            return SLA_VIOLATION;
        if (eventTypeName.equals(SCHEDULED_OPTIMIZATION.name))
            return SCHEDULED_OPTIMIZATION;
        if (eventTypeName.equals(BOTTLENECK_FOUND.name))
            return BOTTLENECK_FOUND;
        if (eventTypeName.equals(CUSTOMER_WORKLOAD_UPDATE.name))
            return CUSTOMER_WORKLOAD_UPDATE;
        if (eventTypeName.equals(OPTIMIZATION_PERIOD.name))
            return OPTIMIZATION_PERIOD;
        if (eventTypeName.equals(CUSTOMER_REDUCES_WORKLOAD.name))
            return CUSTOMER_REDUCES_WORKLOAD;
        if (eventTypeName.equals(WORKLOAD_UPDATE_CUSTOMBER_B.name))
            return WORKLOAD_UPDATE_CUSTOMBER_B;
        if (eventTypeName.equals(SLA_VIOLATED_CUSTOMBER_A.name))
            return SLA_VIOLATED_CUSTOMBER_A;
        return null;
    }
}
